Method: images.list

Retrieves the list of custom images available to the specified project. Custom images are images you create that belong to your project. This method does not get any images that belong to other projects, including publicly-available images, like Debian 8. If you want to get a list of publicly-available images, use this method to make a request to the respective image project, such as debian-cloud or windows-cloud.

HTTP request


GET https://compute.googleapis.com/compute/v1/projects/{project}/global/images

The URLs use gRPC Transcoding syntax.

Path parameters

Parameters
project

string

Project ID for this request.

Query parameters

Parameters
maxResults

integer (uint32 format)

The maximum number of results per page that should be returned. If the number of available results is larger than maxResults, Compute Engine returns a nextPageToken that can be used to get the next page of results in subsequent list requests. Acceptable values are 0 to 500, inclusive. (Default: 500)

pageToken

string

Specifies a page token to use. Set pageToken to the nextPageToken returned by a previous list request to get the next page of results.

filter

string

A filter expression that filters resources listed in the response. Most Compute resources support two types of filter expressions: expressions that support regular expressions and expressions that follow API improvement proposal AIP-160. These two types of filter expressions cannot be mixed in one request.

If you want to use AIP-160, your expression must specify the field name, an operator, and the value that you want to use for filtering. The value must be a string, a number, or a boolean. The operator must be either =, !=, >, <, <=, >= or :.

For example, if you are filtering Compute Engine instances, you can exclude instances named example-instance by specifying name != example-instance.

The :* comparison can be used to test whether a key has been defined. For example, to find all objects with owner label use:

labels.owner:*

You can also filter nested fields. For example, you could specify scheduling.automaticRestart = false to include instances only if they are not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource labels.

To filter on multiple expressions, provide each separate expression within parentheses. For example:

(scheduling.automaticRestart = true)
(cpuPlatform = "Intel Skylake")

By default, each expression is an AND expression. However, you can include AND and OR expressions explicitly. For example:

(cpuPlatform = "Intel Skylake") OR
(cpuPlatform = "Intel Broadwell") AND
(scheduling.automaticRestart = true)

If you want to use a regular expression, use the eq (equal) or ne (not equal) operator against a single un-parenthesized expression with or without quotes or against multiple parenthesized expressions. Examples:

fieldname eq unquoted literal fieldname eq 'single quoted literal' fieldname eq "double quoted literal" (fieldname1 eq literal) (fieldname2 ne "literal")

The literal value is interpreted as a regular expression using Google RE2 library syntax. The literal value must match the entire field.

For example, to filter for instances that do not end with name "instance", you would use name ne .*instance.

You cannot combine constraints on multiple fields using regular expressions.

orderBy

string

Sorts list results by a certain order. By default, results are returned in alphanumerical order based on the resource name.

You can also sort results in descending order based on the creation timestamp using orderBy="creationTimestamp desc". This sorts results based on the creationTimestamp field in reverse chronological order (newest result first). Use this to sort resources like operations so that the newest operation is returned first.

Currently, only sorting by name or creationTimestamp desc is supported.

returnPartialSuccess

boolean

Opt-in for partial success behavior which provides partial results in case of failure. The default value is false.

For example, when partial success behavior is enabled, aggregatedList for a single zone scope either returns all resources in the zone or no resources, with an error code.

Request body

The request body must be empty.

Response body

Contains a list of images.

If successful, the response body contains data with the following structure:

JSON representation
{
  "kind": string,
  "id": string,
  "items": [
    {
      "kind": string,
      "id": string,
      "creationTimestamp": string,
      "name": string,
      "description": string,
      "sourceType": enum,
      "rawDisk": {
        "source": string,
        "sha1Checksum": string,
        "containerType": enum
      },
      "deprecated": {
        "state": enum,
        "replacement": string,
        "deprecated": string,
        "obsolete": string,
        "deleted": string
      },
      "status": enum,
      "archiveSizeBytes": string,
      "diskSizeGb": string,
      "sourceDisk": string,
      "sourceDiskId": string,
      "licenses": [
        string
      ],
      "family": string,
      "imageEncryptionKey": {
        "sha256": string,
        "kmsKeyServiceAccount": string,

        // The following is a list of mutually exclusive fields. At most one of the
        // fields will be set in a response:
        "rawKey": string,
        "rsaEncryptedKey": string,
        "kmsKeyName": string
        // End of mutually exclusive fields.
      },
      "sourceDiskEncryptionKey": {
        "sha256": string,
        "kmsKeyServiceAccount": string,

        // The following is a list of mutually exclusive fields. At most one of the
        // fields will be set in a response:
        "rawKey": string,
        "rsaEncryptedKey": string,
        "kmsKeyName": string
        // End of mutually exclusive fields.
      },
      "selfLink": string,
      "labels": {
        string: string,
        ...
      },
      "labelFingerprint": string,
      "guestOsFeatures": [
        {
          "type": enum
        }
      ],
      "licenseCodes": [
        string
      ],
      "sourceImage": string,
      "sourceImageId": string,
      "sourceImageEncryptionKey": {
        "sha256": string,
        "kmsKeyServiceAccount": string,

        // The following is a list of mutually exclusive fields. At most one of the
        // fields will be set in a response:
        "rawKey": string,
        "rsaEncryptedKey": string,
        "kmsKeyName": string
        // End of mutually exclusive fields.
      },
      "sourceSnapshot": string,
      "sourceSnapshotId": string,
      "sourceSnapshotEncryptionKey": {
        "sha256": string,
        "kmsKeyServiceAccount": string,

        // The following is a list of mutually exclusive fields. At most one of the
        // fields will be set in a response:
        "rawKey": string,
        "rsaEncryptedKey": string,
        "kmsKeyName": string
        // End of mutually exclusive fields.
      },
      "storageLocations": [
        string
      ],
      "shieldedInstanceInitialState": {
        "pk": {
          "content": string,
          "fileType": enum
        },
        "keks": [
          {
            "content": string,
            "fileType": enum
          }
        ],
        "dbs": [
          {
            "content": string,
            "fileType": enum
          }
        ],
        "dbxs": [
          {
            "content": string,
            "fileType": enum
          }
        ]
      },
      "satisfiesPzs": boolean,
      "architecture": enum,
      "enableConfidentialCompute": boolean,
      "satisfiesPzi": boolean,
      "params": {
        "resourceManagerTags": {
          string: string,
          ...
        }
      }
    }
  ],
  "nextPageToken": string,
  "selfLink": string,
  "warning": {
    "code": enum,
    "message": string,
    "data": [
      {
        "key": string,
        "value": string
      }
    ]
  }
}
Fields
kind

string

Output only. Type of resource.

id

string

Output only. Unique identifier for the resource; defined by the server.

items[]

object

A list of Image resources.

items[].kind

string

Output only. Type of the resource. Always compute#image for images.

items[].id

string (uint64 format)

Output only. The unique identifier for the resource. This identifier is defined by the server.

items[].creationTimestamp

string

Output only. Creation timestamp in RFC3339 text format.

items[].name

string

Name of the resource; provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression [a-z]([-a-z0-9]*[a-z0-9])? which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.

items[].description

string

An optional description of this resource. Provide this property when you create the resource.

items[].sourceType

enum

The type of the image used to create this disk. The default and only valid value is RAW.

items[].rawDisk

object

The parameters of the raw disk image.

items[].rawDisk.source

string

The full Google Cloud Storage URL or Artifact Registry path where the raw disk image archive is stored. The following are valid formats:

In order to create an image, you must provide the full or partial URL of one of the following:

  • The rawDisk.source URL
  • The sourceDisk URL
  • The sourceImage URL
  • The sourceSnapshot URL

items[].rawDisk.sha1Checksum
(deprecated)

string

[Deprecated] This field is deprecated. An optional SHA1 checksum of the disk image before unpackaging provided by the client when the disk image is created.

items[].rawDisk.containerType

enum

The format used to encode and transmit the block device, which should be TAR. This is just a container and transmission format and not a runtime format. Provided by the client when the disk image is created.

items[].deprecated

object

Output only. The deprecation status associated with this image.

items[].deprecated.state

enum

The deprecation state of this resource. This can be ACTIVE, DEPRECATED, OBSOLETE, or DELETED. Operations which communicate the end of life date for an image, can use ACTIVE. Operations which create a new resource using a DEPRECATED resource will return successfully, but with a warning indicating the deprecated resource and recommending its replacement. Operations which use OBSOLETE or DELETED resources will be rejected and result in an error.

items[].deprecated.replacement

string

The URL of the suggested replacement for a deprecated resource. The suggested replacement resource must be the same kind of resource as the deprecated resource.

items[].deprecated.deprecated

string

An optional RFC3339 timestamp on or after which the state of this resource is intended to change to DEPRECATED. This is only informational and the status will not change unless the client explicitly changes it.

items[].deprecated.obsolete

string

An optional RFC3339 timestamp on or after which the state of this resource is intended to change to OBSOLETE. This is only informational and the status will not change unless the client explicitly changes it.

items[].deprecated.deleted

string

An optional RFC3339 timestamp on or after which the state of this resource is intended to change to DELETED. This is only informational and the status will not change unless the client explicitly changes it.

items[].status

enum

Output only. The status of the image. An image can be used to create other resources, such as instances, only after the image has been successfully created and the status is set to READY. Possible values are FAILED, PENDING, or READY.

items[].archiveSizeBytes

string (int64 format)

Size of the image tar.gz archive stored in Google Cloud Storage (in bytes).

items[].diskSizeGb

string (int64 format)

Size of the image when restored onto a persistent disk (in GB).

items[].sourceDisk

string

URL of the source disk used to create this image. For example, the following are valid values:

In order to create an image, you must provide the full or partial URL of one of the following:

  • The rawDisk.source URL
  • The sourceDisk URL
  • The sourceImage URL
  • The sourceSnapshot URL

items[].sourceDiskId

string

Output only. The ID value of the disk used to create this image. This value may be used to determine whether the image was taken from the current or a previous instance of a given disk name.

items[].licenses[]

string

Any applicable license URI.

items[].family

string